#include "stdafx.h"
#include "seznam.h"

int PocetVolani = 0;

char *allocVal(char *src)
{
	char *cp = (char *)malloc(strlen(src) + 1);
	if (cp)
		strcpy(cp, src);

	return cp;
}


bool listAdd(listDescr *list, char *txt)
{
	item *tmp, *posl;
	PocetVolani++;
	tmp = createItemFromLine(txt);
	if (tmp == NULL) return false;
	posl = listLast(list);
	if (posl)
	{
		posl->next = tmp;
	}
	else
	{
		list->first = tmp;
	}
	return true;
}

void listShow(listDescr *list)
{
	item *tmp;
	int i;
	if (list->first == NULL)
	{
		puts("Seznam je prazdny");
		return;
	}
	for (tmp = list->first; tmp != NULL; tmp = tmp->next)
	{
		for (i = 0; i < poc_sl; i++)
		{
			if (((ppchar)tmp)[i]) printf("%s", ((ppchar)tmp)[i]);
		}
		puts("");
	}
}

bool listClear(listDescr *list)
{
	item *tmp;
	int i;
	char *cp;
	if (list->first == NULL)
	{
		return false;
	}
	while (list->first != NULL)
	{
		tmp = list->first;
		for (i = 0; i < pocpol; i++)
		{
			cp = ((ppchar)tmp)[i];
			if (cp) free(cp);
		}
		list->first = tmp->next;
		free(tmp);
	}
	return true;
}

void *listZac(listDescr *list)
{
	return list->first;
}


item *listLast(listDescr *list)
{
	item *tmp;
	if (list->first == NULL)
	{
		return NULL;
	}
	for (tmp = list->first; tmp->next != NULL; tmp = tmp->next)
		;
	return tmp;
}

item *createItemFromLine(char *txt)
{
	item *tmp;
	char *cp;
	ppchar pom;
	int n = 0;
	tmp = (item *)malloc(sizeof(item));
	if (tmp == NULL) return tmp;
	memset(tmp, 0, sizeof(item));
	cp = strtok(txt, TOKEN_DELIMS);
	pom = (ppchar)tmp;
	while (cp&&(n<pocpol))
	{
		*pom = allocVal(cp);
		cp = strtok(NULL, TOKEN_DELIMS);
		pom++;
		n++;
	}
	return tmp;
}
